﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace cv13
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ObservableCollection<PersonInfo> personInfos = new ObservableCollection<PersonInfo>();

        public MainWindow()
        {
            InitializeComponent();
            this.panel_ContextBinding.DataContext = this;

            personInfos.Add(new PersonInfo { Name="Dlouhý", Age="56", Email = "dlouhy@7vrsku.com" });
            personInfos.Add(new PersonInfo { Name = "Široký", Age = "65", Email = "siroky@7vrsku.com" });
            personInfos.Add(new PersonInfo { Name = "Krátkozraký", Age = "78", Email = "kratkozrak@7vrsku.com" });

            listBox.ItemsSource = personInfos;
        }

        private void buttonUpdateBinding_Click(object sender, RoutedEventArgs e)
        {
            BindingExpression bindingExpression = textBoxExplicit.GetBindingExpression(TextBox.TextProperty);
            bindingExpression.UpdateSource();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            personInfos.Add(new PersonInfo { Name = "Novej", Age = "18", Email = "newGuy@7vrsku.com" });
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            if (listBox.SelectedItem != null)
                personInfos.Remove(listBox.SelectedItem as PersonInfo);

        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            if (listBox.SelectedItem != null)
                (listBox.SelectedItem as PersonInfo).Name = "Updatovaný";

        }
    }

    public class PersonInfo : INotifyPropertyChanged
    {
        private string name;
        public string Name
        {
            get { return this.name; }
            set
            {
                if (this.name != value)
                {
                    this.name = value;
                    this.OnPropertyChanged("Name");
                }
            }
        }

        public string Age { get; set; }
        public string Email { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
